Subject: bug#54038: 29.0.50; doc-view cannot show different pages in different tabs

From: Juri Linkov <[email-masked]>
Date: Fri, 18 Feb 2022 09:46:03 +0200

>>> 2. Open a pdf file.
>>> 3. Clone the tab using C-x t n.
>>> 4. Move to the next page (n).
>>> 5. Switch back to the original tab C-x t o.
>>> 6. The page is changed here too.
>>>
>>> Expected: The original and the cloned tabs should show different pages,
>>> just like how you can show different pages in different windows/frames.
>>
>> This is expected behavior when you use 'C-x t n' that clones
>> the current tab.  A new clone has exactly the same window.
>> You can confirm this by evaluating in each tab: 'M-:
>> (selected-window)'.
>> It will show the same window number.  But doc-view can show different pages
>> only in different windows.
>
> I see, thanks.  I didn't know that.  If that is the case, the current
> behaviour makes sense.  I was confused primarily because tabs created
> this showing regular buffers were allowed to have different points.

Hmm, maybe 'C-x t n' should not reuse the same window,
but should create a new window with exactly the same state.
This will avoid such problems.  Ok, I'll try to use
window-state-put/get while cloning tabs.

> But, how can I get my desired behaviour tho?  If I create a new tab
> using C-x t 2, it breaks doc-view in a different way.  I am finding it
> hard to describe it in text, so I would appreciate it if you can try it
> out for yourself: essentially, C-x t 2, and then try changing pages.
> Doc-view doesn't show the correct image but the page number in the
> modeline changes.

You are right, it fails with 'C-x t 2' too, so there is a problem
in interaction between doc-view and tab switching.  The current
handling of different windows in doc-view is quite hackish,
so it should be rewritten.  This comment in doc-view.el
proposes a good idea how this should be properly implemented:

      ;; FIXME: This should be done for all windows restored that show
      ;; this buffer.  Basically, the page/slice should be saved as
      ;; window-parameters in the window-state(s) and then restoring this
      ;; window-state should call us back (to interpret/use those parameters).